SystemOrganization addCategory: #HW2!

TestCase subclass: #HW2Tests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HW2'!

!HW2Tests methodsFor: 'as yet unclassified' stamp: 'IsraSunhachawi 6/7/2013 02:09'!
testAsLowerCase

| s lower |
s := 'RaNdOm StRiNg'.

lower := (HW2 new) asLowerCase: s.
self assert: (lower = 'random string').! !

!HW2Tests methodsFor: 'tests' stamp: 'IsraSunhachawi 6/7/2013 01:02'!
testCapitalRegular

| s |
s := (HW2 new) capitals: 'This Is It!!'.
self assert: (s = 'TII').! !

!HW2Tests methodsFor: 'tests' stamp: 'IsraSunhachawi 6/7/2013 01:39'!
testCapitalsUnique

|s|
s := (HW2 new) capitalsUnique: 'This Is It'.
self assert: (s = 'TI').! !

!HW2Tests methodsFor: 'tests' stamp: 'IsraSunhachawi 6/7/2013 00:34'!
testReverseArray

| a |
a := (HW2 new) reverse: #(1 2 5 6 7).
self assert: (a = #(7 6 5 2 1)).! !

!HW2Tests methodsFor: 'tests' stamp: 'IsraSunhachawi 6/7/2013 00:32'!
testReverseString

| s |
s := (HW2 new) reverse: 'ABCDEFG'.
self assert: (s = 'GFEDCBA').! !

Object subclass: #HW2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HW2'!

!HW2 commentStamp: '<historical>' prior: 0!
A HW2 is a class to hold code for Homework 2

Instance Variables
!

!HW2 methodsFor: 'as yet unclassified' stamp: 'IsraSunhachawi 6/7/2013 02:07'!
asLowerCase: aString
	"Returns string with all lower case letters"

	^ aString collect: [ :each | each asLowercase ]	! !

!HW2 methodsFor: 'homework' stamp: 'IsraSunhachawi 6/7/2013 01:03'!
capitals: aString 
"Answers with capital letters of string only in original order"

^ aString select: [:each | each isUppercase  ] ! !

!HW2 methodsFor: 'homework' stamp: 'IsraSunhachawi 6/7/2013 01:42'!
capitalsUnique: aString 

|str set|

str := ''.

str := aString select: [:each | each isUppercase].
set := Set newFrom: str.
^ String newFrom: (set asOrderedCollection).
! !

!HW2 methodsFor: 'as yet unclassified' stamp: 'IsraSunhachawi 6/8/2013 00:56'!
encode: aString
	|pre post|
	pre:= aString asArray
		collect: [ :each | 
			each isLetter
				ifTrue: [ each asciiValue + 1 ]
				ifFalse: [ each ] ].
	
	pre replaceAll: 91 with: 65.  
	pre replaceAll: 123 with: 97.
	post := pre collect: [ :each | (each isNumber) ifTrue: [Character value: each] ifFalse: [ each  ] ]  .
	^ String newFrom: (post asOrderedCollection  ).! !

!HW2 methodsFor: 'homework' stamp: 'IsraSunhachawi 6/7/2013 00:21'!
reverse: aSequenceableCollection
	"reverses order of a sequenceable collection"

	^ aSequenceableCollection reverse! !
